package com.gic.store.service;

import com.gic.store.dto.StoreStrategyDTO;
import com.gic.store.entity.TabStoreStrategy;
import com.github.pagehelper.Page;

/**
 * @author guojx
 * @date 2019/7/4 9:46 AM
 */
public interface StoreStrategyService {

    /**
     * 新增分组策略
     * @param storeStrategyDTO
     * @return
     */
    int saveStoreGroupStrategy(StoreStrategyDTO storeStrategyDTO);

    /**
     * 是否策略名称重复
     * @param record
     * @return
     */
    boolean isRepeatGroupStrategyName(TabStoreStrategy record);

    /**
     * 根据主键查询
     * @param strategyId
     * @return
     */
    TabStoreStrategy getStoreStrategyById(Integer strategyId);

    /**
     * 查询下一个排序值的属性值
     * @param enterpriseId
     * @param sort
     * @param strategyType
     * @return
     */
    TabStoreStrategy getNextSort(int enterpriseId, double sort, int strategyType);

    /**
     * 查询上一个排序值的属性值
     * @param enterpriseId
     * @param sort
     * @param strategyType
     * @return
     */
    TabStoreStrategy getPrevSort(int enterpriseId, double sort, int strategyType);

    /**
     * 置顶、置底，自定义序号
     * @param strategyId
     * @param enterpriseId
     * @param setValue
     * @param strategyType
     */
    void setStoreStrategySort(int strategyId, int enterpriseId, int setValue, int strategyType);

    double getMinSort(int enterpriseId, int strategyType);

    /**
     * 置底
     * @param enterpriseId
     * @param strategyId
     * @param strategyType
     */
    void sortBottom(int enterpriseId, int strategyId, int strategyType);

    /**
     * 置顶
     * @param enterpriseId
     * @param strategyId
     * @param strategyType
     */
    void sortTopping(int enterpriseId, int strategyId, int strategyType);

    /**
     * 删除分组策略（单条）
     * @param strategyId
     * @return
     */
    int deleteStoreGroupStrategy(int strategyId);

    /**
     * 修改分组策略
     * @param storeStrategyDTO
     * @return
     */
    int modifyStoreGroupStrategy(StoreStrategyDTO storeStrategyDTO);

    /**
     * 分页查询数据
     * @param enterpriseId
     * @param search
     * @param strategyType
     * @param pageNum
     * @param pageSize
     * @return
     */
    Page<TabStoreStrategy> listStoreStrategy(int enterpriseId, String search, int strategyType, Integer pageNum, Integer pageSize);

    void updateSortById(int strategyId, double sort);

}
