package com.gic.store.service.impl;

import com.gic.store.dao.mapper.TabStoreGroupMapper;
import com.gic.store.entity.TabStoreGroup;
import com.gic.store.service.StoreGroupService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @author guojx
 * @date 2019/7/3 2:18 PM
 */
@Service("storeGroupService")
public class StoreGroupServiceImpl implements StoreGroupService{
    @Autowired
    private TabStoreGroupMapper tabStoreGroupMapper;

    @Override
    public TabStoreGroup getStoreGroupByName(String storeGroupName, Integer enterpriseId) {
        return tabStoreGroupMapper.getStoreGroupByName(storeGroupName, enterpriseId);
    }

    @Override
    public void dragSort(TabStoreGroup storeGroup, Integer toSortValue) {
        Integer enterpriseId = storeGroup.getEnterpriseId();
        Integer groupLevel = storeGroup.getGroupLevel();
        Integer fromSortValue = storeGroup.getSort();
        Integer storeGroupId = storeGroup.getStoreGroupId();

        TabStoreGroup record = new TabStoreGroup();
        record.setEnterpriseId(enterpriseId);
        record.setGroupLevel(groupLevel);
        List<TabStoreGroup> tabStoreGroupList = tabStoreGroupMapper.listStoreGroup(record);
        if (fromSortValue > toSortValue) {
            //如果是向上拖拽
            for (int i = 0, length = tabStoreGroupList.size(); i < length; i ++) {
                TabStoreGroup tabStoreGroup = tabStoreGroupList.get(i);
                //如果大于setSortValue，都需要降低排序值,往后推
                boolean isNeedDown = tabStoreGroup.getSort() >= toSortValue && tabStoreGroup.getSort() < fromSortValue;
                if (isNeedDown) {
                    updateSort(tabStoreGroupList.get(i + 1).getSort(), tabStoreGroup.getStoreGroupId());
                }
            }
        } else if (fromSortValue < toSortValue) {
            //向下拖拽
            for (int i = 0, length = tabStoreGroupList.size(); i < length; i ++) {
                TabStoreGroup tabStoreGroup = tabStoreGroupList.get(i);
                boolean isNeedUp = tabStoreGroup.getSort() <= toSortValue && tabStoreGroup.getSort() > fromSortValue;
                if (isNeedUp) {
                    updateSort(tabStoreGroupList.get(i - 1).getSort(), tabStoreGroup.getStoreGroupId());
                }
            }
        }

        updateSort(toSortValue, storeGroupId);
    }

    @Override
    public TabStoreGroup getStoreGroupById(Integer storeGroupId) {
        return tabStoreGroupMapper.selectByPrimaryKey(storeGroupId);
    }

    @Override
    public void updateSort(Integer sort, Integer storeGroupId) {
        TabStoreGroup record = new TabStoreGroup();
        record.setStoreGroupId(storeGroupId);
        record.setSort(sort);
        tabStoreGroupMapper.updateByPrimaryKeySelective(record);
    }
}
